#ifndef __DISP_MEDIATYPE_H__
#define __DISP_MEDIATYPE_H__

#include <dshow.h>

#ifdef __cplusplus 

typedef struct{
  const GUID *guid;
  char *list;
} media_guid_list;

#endif

#ifdef __cplusplus 
extern "C" {
#endif

void disp_guid(const GUID *guid);
void disp_mediatype(const AM_MEDIA_TYPE *amt);
void disp_majortype(const GUID *guid);
void disp_subtype(const GUID *guid);
void disp_formattype(const GUID *guid);

#ifdef __cplusplus 
}
#endif
#endif
