/*
  Windowsp JpėpTu[` Ver.1.10

  v s_malloc

  ֐ s_camera_*

  Ver.1.00 Tu[`AJėpCu
*/
#include <stdio.h>
#include <stdlib.h>

#include "s_cameralib.h"

extern "C" {
#include "s_malloc.h"
}
#include "disp_mediatype.h"

// --------------------------------------------------------------
// Ch֌W̃Tu[`
// --------------------------------------------------------------
// Ch񒆂Ɏw肵}`oCg񂪑݂邩(Jp)
// ݂FTRUEԂ / ݂ȂFFALSEԂ
int is_exist_str_in_wstr(char key[],LPCWSTR target)
{
  int len;
  WCHAR *buf;
  int ret_code;

  len = MultiByteToWideChar(CP_ACP, 0, key, -1, NULL, 0);
  buf = xalloc(WCHAR,len);
  len = MultiByteToWideChar(CP_ACP, 0, key, -1, buf, len);
  ret_code = (wcsstr(target, buf) != NULL);
  free(buf);
  return(ret_code);
}

// --------------------------------------------------------------
// Ŝ̏
// --------------------------------------------------------------
static int s_cameralib_initialize_flag = FALSE;
// :FALSEԂBs:TRUEԂB
int s_camera_init(int debug_flag)
{
	HRESULT hr;

	if (!s_cameralib_initialize_flag)
	{
		hr = CoInitialize(NULL); // COMIuWFNg̏
		if (FAILED(hr))
		{
			if (debug_flag) printf("ERROR - Could not initialize COM library");
			return(TRUE);
		}
		else
		{
			s_cameralib_initialize_flag = TRUE;
		}
	}
	return(FALSE);
}

void s_camera_end(void)
{
	if (s_cameralib_initialize_flag) CoUninitialize();
	s_cameralib_initialize_flag = FALSE;
}

// --------------------------------------------------------------
// ڑĂJ̐Ԃ
int s_camera_count(void)
{
	int ret_code;
	HRESULT hr;
	ICreateDevEnum *pDevEnum;
	IEnumMoniker *pClassEnum = NULL;
	IMoniker * pMoniker;

	ret_code = 0;
	if (s_camera_init(FALSE)) return(0);
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC, // J̗񋓎q̏
		IID_ICreateDevEnum, (void **)&pDevEnum);
	if (FAILED(hr)) return(0);
	hr = pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,
		&pClassEnum, 0);
	if (FAILED(hr)) return(0);
	while (pClassEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
		pMoniker->Release();
		ret_code++;
	}
	pClassEnum->Release();
	pDevEnum->Release();
	return(ret_code);
}

// O͐J̔ԍԂ
int s_camera_search(char *camera_name,int debug_flag)
{
  int no,ret_code;
  HRESULT hr;
  ICreateDevEnum *pDevEnum;
  IMoniker * pMoniker;
  IEnumMoniker *pClassEnum = NULL;
  IPropertyBag *pPropBag;
  VARIANT varName;

  ret_code = -1;

  if(camera_name == NULL)
    {
      if(debug_flag) printf("ERROR - No camera name.");
      return(ret_code);
    }
  if(s_camera_init(debug_flag)) return(ret_code);
  hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC, // J̗񋓎q̏
	      IID_ICreateDevEnum, (void **)&pDevEnum);
  if(FAILED(hr))
    {
      if(debug_flag) printf("ERROR - Could not create the Device Enum");
      return(ret_code);
    }
  hr = pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,
	  &pClassEnum, 0);
  if(hr != S_OK)
    {
      pDevEnum->Release() ;
      return(ret_code);
    }
  ret_code = -1;
  no = 0;
  while((ret_code == -1) && (pClassEnum->Next(1, &pMoniker, NULL) == S_OK))
    {
      hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag,(void**)(&pPropBag));
      if(SUCCEEDED(hr))
	{
	  // ܂̓thB
	  VariantInit(&varName);
	  hr = pPropBag->Read(L"Description", &varName, 0);
	  if(SUCCEEDED(hr))
	    {
	      if(is_exist_str_in_wstr(camera_name,varName.bstrVal))
	        {
		  // J
		  ret_code = no;
	        }
	      VariantClear(&varName); 
	    }
	  hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	  if(SUCCEEDED(hr))
	    {
	      if(is_exist_str_in_wstr(camera_name,varName.bstrVal))
	        {
		  // J
		  ret_code = no;
	        }
	      VariantClear(&varName); 
	    }
	  pPropBag->Release();
	}
      pMoniker->Release();
      no++;
    }
  pClassEnum->Release();
  pDevEnum->Release();
  return(ret_code);
}
