#ifndef __CAM_LIB_H__
#define __CAM_LIB_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "s_qedit.h"

// }`obt@̐(TvOoŎgp)
#define NBUF	8

// 摜tH[}bg̎w
enum{MS_DEF=0,
    MS_RGB24,MS_YUY2,MS_UYVY,MS_I420,MS_MJPEG,
    MS_MAX};

// JLv`ɊւZbg
typedef struct {
  IGraphBuilder *pGraph;		// Otr_
  IMediaControl *pMediaControl;
  ISampleGrabber *pSGrab;		// TvOo
  int width,height;			// 摜TCY
  long maxbufsize;			// obt@őTCY
  long getsize[NBUF];			// 擾obt@TCY
  unsigned char *dib_data[NBUF];	// 擾obt@
  int isempty;				// obt@󂩂ǂtO
  int bufin,bufout;			// obt@JnԍAIԍ
#ifdef SHOWGRAPH
  DWORD dwGraphRegister;		// graphedito^ԍ
#endif
} camera_data;

#include "s_value.h"
#include "s_malloc.h"

int s_camera_init(int debug_flag);
void s_camera_end(void);
int s_camera_count(void);
int s_camera_search(char *camera_name,int debug_mode);

#ifdef __cplusplus
}
#endif

#pragma comment(lib,"winmm.lib")

#endif
